;AhkSnap based on FreeSnap and WinManagement_snap
;WinManagement_snap v0.2-- farr independent version!
;Modified version of jgpaiva's great WinManagement (by Armando)
;date: July 2007 - January 2008
;Function: manage windows
;Source: http://www.donationcoder.com/forum/index.php?topic=11725.0

; further modifications by lanux128
; added snap undo, center windows, resize up/down via numpad plus/minus
; updated: Jan 9, 2012 4:46:37 PM

#Persistent
#SingleInstance, Force
#NoEnv
;#NoTrayIcon

SetBatchLines, -1
SetWorkingDir, %A_ScriptDir%
DetectHiddenWindows, Off	; they're hidden for a reason.
SetTitleMatchMode, 2		; partial match
SendMode, Input


oldpos = 0   ; save old position
OldWinUp=       ; save old windows id
OldWinDown=       ; save old windows id
OldWinLeft=       ; save old windows id
OldWinRight=       ; save old windows id
;;get the screen center coords;
xCenter:=(A_ScreenWidth/2)
yCenter:=(A_ScreenHeight/2)

StringTrimRight, ScriptName, A_ScriptName, 4
INI_File=%ScriptName%.ini
IfNotExist, %INI_File%
{
  ; yet to do, right now it only reminds the user that no INI was found  
  ;to create ini file and add all the variables
  ToolTip, %INI_File% not found.
  SetTimer, RemoveToolTip, 5000
}

IniRead,iniSize,%INI_File%,Size
Loop, parse, iniSize, `n, `r
{
    RegExMatch( A_LoopField, "\s*(\d+),\s*(\d+)", WindowSize )  ; with help from ewemoa & Skwire
    myWindowWidth%A_Index% := WindowSize1
    myWindowHeight%A_Index% := WindowSize2
    MaxCount := A_Index
}

; adding of an "about box" to display credits
AnAboutBox=
(
AhkSnap`n
Win+Up    ::  snap top and undo                    
Win+Down  ::  snap bottom and undo               
Win+Left  ::  snap left and undo                 
Win+Right ::  snap right and undo               
                                    
Win+Numpad7 :: move to top-left corner               
Win+Numpad9 :: move to top-right corner              
Win+Numpad1 :: move to bottom-left corner            
Win+Numpad3 :: move to bottom-right corner                                                     
Win+Numpad5 :: center window

Win+NumpadPlus :: resize up
Win+NumpadMinus :: resize down
_________________________________________________         
Current version of AutoHotkey is %A_AhkVersion%`n
)

; Menu stuff
If Not A_IsCompiled
  IfExist, %ScriptName%.ico
    Menu, Tray, Icon, %ScriptName%.ico

Menu, Tray, Tip, %ScriptName%`, a FreeSnap clone
Menu, Tray, NoStandard
Menu, Tray, Add, About, SHOWKEYS
Menu, Tray, Add, Quit, QUIT
Menu, Tray, Default, About

; Load menu icons here
IfExist, %A_ScriptDir%\icons\help.png
  Menu, Tray, Icon, About, icons\help.png,, 0
IfExist, %A_ScriptDir%\icons\quit.png
  Menu, Tray, Icon, Quit, icons\quit.png,, 0

Return

QUIT:
ExitApp
Return

SHOWKEYS:
Text= %AnAboutBox%
Splashimage, , B1 w600 CTBlue CwYellow Fs11 Ws650, %Text%, , , Verdana
Sleep, 10000
Splashimage, off
Return

; *****MOVE WINDOW TO SCREEN CORNERS SECTION*****

; Move window to Up-Left corner
#Numpad7::
; these hotkeys can be modified. (# = winkey. ^ = ctrl key. + = shift key. )
{
SysGet, OutputVar, MonitorWorkArea,1
WinGetPos, WinLeft, WinTop, WinWidth, WinHeight,A
WinGetClass,WinClass,A
WinGet,WindowId,id,A
  WinMove, ahk_id %WindowId%, ,OutputVarLeft,OutputVarTop, %WinWidth%,%WinHeight%
  return
}

; Move window to Up-Right corner
#Numpad9::
{
SysGet, OutputVar, MonitorWorkArea,1
WinGetPos, WinLeft, WinTop, WinWidth, WinHeight,A
WinGetClass,WinClass,A
WinGet,WindowId,id,A
WinMove, ahk_id %WindowId%, , (OutputVarRight-WinWidth),OutputVarTop, %WinWidth%,%WinHeight%
  return 
}

; Move window to Low-Left corner
#Numpad1::
{
SysGet, OutputVar, MonitorWorkArea,1
WinGetPos, WinLeft, WinTop, WinWidth, WinHeight,A
WinGetClass,WinClass,A
WinGet,WindowId,id,A
WinMove, ahk_id %WindowId%, , OutputVarLeft,(OutputVarBottom-WinHeight), %WinWidth%,%WinHeight%
  return 
}

; Move window to Low-Right corner
#Numpad3::
{
SysGet, OutputVar, MonitorWorkArea,1
WinGetPos, WinLeft, WinTop, WinWidth, WinHeight,A
WinGetClass,WinClass,A
WinGet,WindowId,id,A
WinMove, ahk_id %WindowId%, ,(OutputVarRight-WinWidth),(OutputVarBottom-WinHeight), %WinWidth%,%WinHeight%
  return 
}


; *****MOVE WINDOW TO THE CENTER OF SCREEN *****

; Move window to the center
#Numpad5::  ; these hotkeys can be modified. (# = winkey. ^ = ctrl key. + = shift key. )
{
SysGet, OutputVar, MonitorWorkArea,1
WinGetPos, WinLeft, WinTop, WinWidth, WinHeight,A
WinGetClass,WinClass,A
WinGet,WindowId,id,A
  xCenter:=(OutputVarRight-WinWidth)/2
  yCenter:=(OutputVarBottom-WinHeight)/2
  WinMove, ahk_id %WindowId%, ,xCenter,yCenter, %WinWidth%,%WinHeight%
  return
}


; *****SNAP WINDOW BORDERS TO SCREEN EDGES SECTION*****

; Snap top window edge to screen top
#up::
{
SysGet, OutputVar, MonitorWorkArea,1
WinGetPos, WinLeft, WinTop, WinWidth, WinHeight,A
WinGetClass,WinClass,A
WinGet,WindowId,id,A

;; save win pos then if win ID matches, change back to old size 
If OldWinUp=ahk_id %WindowId%
{
  ; revert to earlier
  WinMove, ahk_id %WindowId%, , %saveLeft%, %saveTop%, %saveWidth%, %saveHeight%
  oldpos = 0
  OldWinUp = 
}
Else
{
  ; save current dimension
  saveLeft := WinLeft 
  saveTop := WinTop
  saveWidth := WinWidth
  saveHeight := WinHeight
  ; switch to new dimension
  WinMove, ahk_id %WindowId%, , %Winleft%, OutputVarTop, %WinWidth%, (WinHeight+(WinTop-OutputVarTop))
  OldWinUp=ahk_id %WindowId%
  oldpos = 1
}
 
  return
}

; Snap bottom window edge to screen bottom
#down::
{
SysGet, OutputVar, MonitorWorkArea,1
WinGetPos, WinLeft, WinTop, WinWidth, WinHeight,A
WinGetClass,WinClass,A
WinGet,WindowId,id,A

;; save win pos then if win ID matches, change back to old size 
If OldWinDown=ahk_id %WindowId%
{
  ; revert to earlier
  WinMove, ahk_id %WindowId%, , %saveLeft%, %saveTop%, %saveWidth%, %saveHeight%
  oldpos = 0
  OldWinDown = 
}
Else
{
  ; save current dimension
  saveLeft := WinLeft 
  saveTop := WinTop
  saveWidth := WinWidth
  saveHeight := WinHeight
  ; switch to new dimension
  WinMove, ahk_id %WindowId%, , %Winleft%, %WinTop%, %WinWidth%, ((OutputVarBottom-(WinHeight+WinTop))+WinHeight)
  OldWinDown=ahk_id %WindowId%
  oldpos = 1
}

  return
}


; Snap left window edge to screen left
#Left::
{
SysGet, OutputVar, MonitorWorkArea,1
WinGetPos, WinLeft, WinTop, WinWidth, WinHeight,A
WinGetClass,WinClass,A
WinGet,WindowId,id,A

;; save win pos then if win ID matches, change back to old size 
If OldWinLeft=ahk_id %WindowId%
{
  ; revert to earlier
  WinMove, ahk_id %WindowId%, , %saveLeft%, %saveTop%, %saveWidth%, %saveHeight%
  oldpos = 0
  OldWinLeft = 
}
Else
{
  ; save current dimension
  saveLeft := WinLeft 
  saveTop := WinTop
  saveWidth := WinWidth
  saveHeight := WinHeight
  ; switch to new dimension
  WinMove, ahk_id %WindowId%, , OutputVarLeft, %WinTop%, (WinWidth+(WinLeft-OutputVarLeft)), %WinHeight%
  OldWinLeft=ahk_id %WindowId%
  oldpos = 1
}
  return
}

; Snap Right window edge to screen right
#Right::
{
SysGet, OutputVar, MonitorWorkArea,1
WinGetPos, WinLeft, WinTop, WinWidth, WinHeight,A
WinGetClass,WinClass,A
WinGet,WindowId,id,A

;; save win pos then if win ID matches, change back to old size 
If OldWinRight=ahk_id %WindowId%
{
  ;WinGetPos, saveX, saveY, saveWidth, saveHeight, ahk_id %WindowId% 
  ; revert to earlier
  WinMove, ahk_id %WindowId%, , %saveLeft%, %saveTop%, %saveWidth%, %saveHeight%
  oldpos = 0
  OldWinRight = 
}
Else
{
  ; save current dimension
  saveLeft := WinLeft 
  saveTop := WinTop
  saveWidth := WinWidth
  saveHeight := WinHeight
  ; switch to new dimension
  WinMove, ahk_id %WindowId%, , Winleft, %WinTop%, (WinWidth+(OutputVarRight-(WinLeft+WinWidth))), %WinHeight%
  OldWinRight=ahk_id %WindowId%
  oldpos = 1
}
  return
}


;Switch through different sizes 
; http://www.autohotkey.com/forum/viewtopic.php?p=473421#473421 :: girlgamer
; use the Numpad + key to cycle forward through the windows' size
#NumpadAdd::
{
count ++
IfGreater, count, %MaxCount%
      count = 1 
Gosub, ResizeMe
  return
}

; http://www.autohotkey.com/forum/viewtopic.php?p=473421#473421 :: girlgamer
; use the Numpad  - key to cycle backwards through the windows' size
#UseHook          ; Forces the use of the hook to implement all or some keyboard hotkeys. - works in win7

#NumpadSub::
{
count --
IfLess, count, 1
      count = %MaxCount%
Gosub, ResizeMe
  return
}

ResizeMe:
  SysGet, OutputVar, MonitorWorkArea,1
  WinGetClass,WinClass,A
  WinGet,WindowId,id,A
  WinGet, IsMax, MinMax, ahk_id %WindowId%
  If (IsMax)
    {
    ToolTip THe window is maximized.`nRestoring it to normal size first., %xCenter%, %yCenter%
    WinRestore, ahk_id %WindowId%
    SetTimer, RemoveToolTip, 5000
    Return
    }

  WinGetPos, WinLeft, WinTop, WinWidth, WinHeight,A
  xCenter:=(OutputVarRight-WinWidth)/2
  yCenter:=(OutputVarBottom-WinHeight)/2
  ;; always center the window after resizing to prevent from going off-screen
  WinMove, ahk_id %WindowId%, , %Winleft%, %WinTop%, myWindowWidth%count%, myWindowHeight%count%
  curWindowWidth := myWindowWidth%count%
  curWindowHeight := myWindowHeight%count%
  SetTimer, RemoveToolTip, 5000
Return

RemoveToolTip:
SetTimer, RemoveToolTip, Off
ToolTip
Return
